# NOTE: Derived from ./blib/lib/Text/EP3.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Text::EP3;

#line 1310 "./blib/lib/Text/EP3.pm (autosplit into ./blib/lib/auto/Text/EP3/else.al)"
sub else
# Skip to endif if there is an ifdef in progress.
# The basic else
# usage: @else
{
    my $self = shift;
    my(@input_string) = @_;
    my(@string);
    my($inline, $directive, $initifdef);
 
    print "$self->{Line_Comment}EP3->else: Entered else.  Line $Text::EP3::line of $Text::EP3::filename\n"		if $self->{Debug} & 1;
    $inline = $input_string[0];
    @string = split(' ',$inline);
 
    # parse key string
    $directive = shift @string;
 
    if (! $self->{Ifdef}) {
        die "Unexpected $directive";
    }
 
    print "$self->{Line_Comment}EP3->else: Got an else or el[s]if: Ifdef = $self->{Ifdef}\n" if $self->{Debug} & 16;
    # Set initifdef = to the current count for nesting checks
    $initifdef = $self->{Ifdef};
    while (<$Text::EP3::filehandle>) {
	$Text::EP3::line = $.;
        if (/^\s*$self->{DPAT}if/) {
            # Inside of loops, keep an index for the ifdef
            $self->{Ifdef} ++;
            print "$self->{Line_Comment}EP3->else: Upping ifdef count = $self->{Ifdef}\n" if $self->{Debug} & 16;
        }
  
        if (/^\s*$self->{DPAT}endif/) {
            $self->{Ifdef}--;
            print "$self->{Line_Comment}EP3->else: Got an endif: Ifdef = $self->{Ifdef}\n" if $self->{Debug} & 16;
            print "$self->{Line_Comment}EP3->else:               level = $initifdef\n" if $self->{Debug} & 16;
            # If this is still in a nested loop, pass it by
            next if $initifdef <= $self->{Ifdef};
            #break out of while loop
            last;
        }
    }
    print "The else or el[s]if is done: Ifdef = $self->{Ifdef}\n" if $self->{Debug}
    &16;
}

# end of Text::EP3::else
1;
