# NOTE: Derived from ./blib/lib/Text/EP3.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Text::EP3;

#line 1366 "./blib/lib/Text/EP3.pm (autosplit into ./blib/lib/auto/Text/EP3/ifdef.al)"
sub ifdef
# Read to endif if the key is defined. Otherwise, ignore to endif
# The basic ifdef
# usage: @ifdef key
{
    my $self = shift;
    my(@input_string) = @_;
    my(@string);
    my($inline, $directive, $key, $skip, $initifdef);
 
    print "$self->{Line_Comment}EP3->ifdef: Entered ifdef.  Line $Text::EP3::line of $Text::EP3::filename\n"		if $self->{Debug} & 1;
    $inline = $input_string[0];
    @string = split(' ',$inline);
 
    # parse key string
    $directive = shift @string;
    $key = shift @string;
 
    # Bumb up the ifdef count if this is a new ifdef
    if ($directive !~ /^\s*$self->{DPAT}el[s]*if/) {
        $self->{Ifdef}++;
    }
 
    print "checking if self->{Keyline}{$key} is defined ->$self->{Keyline}{$key}<-\n" if $self->{Debug} & 16;
    print "directive = $directive\n" if $self->{Debug} & 16;
    print "Ifdef = $self->{Ifdef}\n" if $self->{Debug} & 16;
 
    # see if the key is defined
    if (! defined $self->{Keyline}{$key}) {
        $skip = 1;
    }
 
    #This is opposite of the ifndef
    if ($directive =~ /^\s*$self->{DPAT}ifndef/) {
        print "We have and ifndef\n" if $self->{Debug} & 16;
        $skip = !($skip);
    }
 
    # If skip, continue until endif
    if ($skip) {
        # Set initifdef = to the current count for nesting checks
        $initifdef = $self->{Ifdef};
        while (<$Text::EP3::filehandle>) {
	    $Text::EP3::line = $.;
            if (/^\s*$self->{DPAT}if/) {
                # Inside of loops, keep an index for the ifdef
                $self->{Ifdef} ++;
                print "Upping ifdef level = $self->{Ifdef}\n" if $self->{Debug} & 16;
            }
   
            if (/^\s*$self->{DPAT}else/) {
                # If this is in a nested loop, pass it by
                print " Got an else: Ifdef = $self->{Ifdef}\n" if $self->{Debug} & 16;
                next if $initifdef < $self->{Ifdef};
                #break out of while loop
                last;
            }
            if (/^\s*$self->{DPAT}el[s]*if/) {
                # If this is in a nested loop, pass it by
                print "$self->{Line_Comment}EP3->ifdef: Got an el[s]if: Ifdef = $self->{Ifdef}\n" if $self->{Debug} & 16;
                next if $initifdef < $self->{Ifdef};
                #break out of while loop
                $self->ifdef($_);
                last;
            }
            if (/^\s*$self->{DPAT}endif/) {
                $self->{Ifdef}--;
                print "$self->{Line_Comment}EP3->ifdef: Got an endif: Ifdef = $self->{Ifdef}\n" if $self->{Debug} & 16;
                print "$self->{Line_Comment}EP3->ifdef:               level = $initifdef\n" if $self->{Debug} & 16;
                # If this is still in a nested loop, pass it by
                next if $initifdef <= $self->{Ifdef};
                #break out of while loop
                last;
            }
        }
    }
}

# end of Text::EP3::ifdef
1;
