# NOTE: Derived from ./blib/lib/Text/EP3.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Text::EP3;

#line 1781 "./blib/lib/Text/EP3.pm (autosplit into ./blib/lib/auto/Text/EP3/comment.al)"
# Turn comment inclusion 
# one of on,off,pervious value, default value
# usage: @comment on|off|previous|default
sub comment
{
    my $self = shift;
    my(@input_string) = @_;
    my($inline, $directive, $key);
    $inline = $input_string[0];
    print "$self->{Line_Comment}EP3->comment: Entered comment.  Line $Text::EP3::line of $Text::EP3::filename    $input_string[1]\n"		if $self->{Debug} & 2;
    my @string = split(' ',$inline);
 
    $directive = shift @string;
    $key = shift @string;
    if ($key =~ /on/i) {
       # Set previous up so source that the comment routine can restore them
       $self->{Keep_Previous} = $self->{Keep_Comments};
       $self->{Protect_Previous} = $self->{Protect_Comments};
       if ($directive =~ /comment/){
          $self->{Keep_Comments} = 1;
       }
       else
       {
          $self->{Protect_Comments} = 1;
       }
    }
    elsif ($key =~ /off/i) {
        # Set previous up so source that the comment routine can restore them
        $self->{Keep_Previous} = $self->{Keep_Comments};
        $self->{Protect_Previous} = $self->{Protect_Comments};
        if ($directive =~ /comment/){
            $self->{Keep_Comments} = 0;
        }
        else {
            $self->{Protect_Comments} = 0;
        }
    }
    elsif ($key =~ /PRE/i) {
        if ($directive =~ /comment/){
            $self->{Keep_Comments} = $self->{Keep_Previous};
        }
        else {
            $self->{Protect_Comments} = $self->{Protect_Previous};
        }
    }
    elsif ($key =~ /DEF/i) {
        if ($directive =~ /comment/){
            $self->{Keep_Comments} = $self->{Keep_Default};
        }
        else {
            $self->{Protect_Comments} = $self->{Protect_Default};
        }
    }
    else {
        die("Unkown $directive key, $key\n");
    }
}

# end of Text::EP3::comment
1;
