# NOTE: Derived from ./blib/lib/Text/EP3.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Text::EP3;

#line 1164 "./blib/lib/Text/EP3.pm (autosplit into ./blib/lib/auto/Text/EP3/undef.al)"
sub undef
# Undefine a key
# usage: @undef key
{
    my $self = shift;
    my(@input_string) = @_;
    my(@string);
    my($inline, $directive, $key);
 
    $inline = $input_string[0];
    @string = split(' ',$inline);
    print "$self->{Line_Comment}EP3->undef: Entered undef.  Line $Text::EP3::line of $Text::EP3::filename  $string[0] $string[1]\n"	if $self->{Debug} & 1;
 
    # parse key string
    $directive = shift @string;
    $key = shift @string;
 
    # make sure there is a key
    if ($key eq '') {
        die "No key definition in $self->{Delimeter}$directive, line
	$Text::EP3::line";
    }
 
    # Error if there is extraneous stuffs.
    if ($#string >= 0) {
        die "Extraneous information: $self->{Delimeter}directive $key ->" . join (' ',@string) . " <-\n";
    }
 
    # make sure we have seen this key
    if ($self->{Keyline}{$key} eq '') {
        carp "Key $key on line $Text::EP3::line of file $Text::EP3::filename not previously defined:" if $self->{Debug} & 4;
    }
    else {
        splice (@{$self->{Keylist}},$self->{Keyfind}{$key},1);
        delete $self->{Keyline}{$key} if exists $self->{Keyline}{$key};
        delete $self->{Keyfile}{$key} if exists $self->{Keyfile}{$key};
        delete $self->{Define_List}{$key} if exists $self->{Define_List}{$key};
        delete $self->{Replace_List}{$key} if exists $self->{Replace_List}{$key};
        delete $self->{Keyfind}{$key} if exists $self->{Keyfind}{$key};
        delete $self->{Macro_Value}{$key} if exists $self->{Macro_Value}{$key};
        delete $self->{Macro_Vars}{$key} if exists $self->{Macro_Vars}{$key};
    }
 
}

# end of Text::EP3::undef
1;
